# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # Application Upgrade Domain Complete event.
    #
    class ApplicationUpgradeDomainCompleteEvent < ApplicationEvent

      include MsRestAzure


      def initialize
        @Kind = "ApplicationUpgradeDomainComplete"
      end

      attr_accessor :Kind

      # @return [String] Application type name.
      attr_accessor :application_type_name

      # @return [String] Current Application type version.
      attr_accessor :current_application_type_version

      # @return [String] Target Application type version.
      attr_accessor :application_type_version

      # @return [String] State of upgrade.
      attr_accessor :upgrade_state

      # @return [String] Upgrade domains.
      attr_accessor :upgrade_domains

      # @return [Float] Upgrade time of domain in milli-seconds.
      attr_accessor :upgrade_domain_elapsed_time_in_ms


      #
      # Mapper for ApplicationUpgradeDomainCompleteEvent class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationUpgradeDomainComplete',
          type: {
            name: 'Composite',
            class_name: 'ApplicationUpgradeDomainCompleteEvent',
            model_properties: {
              event_instance_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'EventInstanceId',
                type: {
                  name: 'String'
                }
              },
              time_stamp: {
                client_side_validation: true,
                required: true,
                serialized_name: 'TimeStamp',
                type: {
                  name: 'DateTime'
                }
              },
              has_correlated_events: {
                client_side_validation: true,
                required: false,
                serialized_name: 'HasCorrelatedEvents',
                type: {
                  name: 'Boolean'
                }
              },
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              application_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ApplicationId',
                type: {
                  name: 'String'
                }
              },
              application_type_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ApplicationTypeName',
                type: {
                  name: 'String'
                }
              },
              current_application_type_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CurrentApplicationTypeVersion',
                type: {
                  name: 'String'
                }
              },
              application_type_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ApplicationTypeVersion',
                type: {
                  name: 'String'
                }
              },
              upgrade_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeState',
                type: {
                  name: 'String'
                }
              },
              upgrade_domains: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeDomains',
                type: {
                  name: 'String'
                }
              },
              upgrade_domain_elapsed_time_in_ms: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeDomainElapsedTimeInMs',
                type: {
                  name: 'Double'
                }
              }
            }
          }
        }
      end
    end
  end
end
