# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # Describes the parameters for updating an ongoing application upgrade.
    #
    class ApplicationUpgradeUpdateDescription

      include MsRestAzure

      # @return [String] The name of the application, including the 'fabric:'
      # URI scheme.
      attr_accessor :name

      # @return [UpgradeKind] The kind of upgrade out of the following possible
      # values. Possible values include: 'Invalid', 'Rolling'. Default value:
      # 'Rolling' .
      attr_accessor :upgrade_kind

      # @return [ApplicationHealthPolicy] Defines a health policy used to
      # evaluate the health of an application or one of its children entities.
      attr_accessor :application_health_policy

      # @return [RollingUpgradeUpdateDescription] Describes the parameters for
      # updating a rolling upgrade of application or cluster.
      attr_accessor :update_description


      #
      # Mapper for ApplicationUpgradeUpdateDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationUpgradeUpdateDescription',
          type: {
            name: 'Composite',
            class_name: 'ApplicationUpgradeUpdateDescription',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Name',
                type: {
                  name: 'String'
                }
              },
              upgrade_kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'UpgradeKind',
                default_value: 'Rolling',
                type: {
                  name: 'String'
                }
              },
              application_health_policy: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ApplicationHealthPolicy',
                type: {
                  name: 'Composite',
                  class_name: 'ApplicationHealthPolicy'
                }
              },
              update_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpdateDescription',
                type: {
                  name: 'Composite',
                  class_name: 'RollingUpgradeUpdateDescription'
                }
              }
            }
          }
        }
      end
    end
  end
end
