# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # A paged list of Service Fabric names. The list is paged when all of the
    # results cannot fit in a single message. The next set of results can be
    # obtained by executing the same query with the continuation token provided
    # in this list.
    #
    class PagedSubNameInfoList

      include MsRestAzure

      # @return [String] The continuation token parameter is used to obtain
      # next set of results. The continuation token is included in the response
      # of the API when the results from the system do not fit in a single
      # response. When this value is passed to the next API call, the API
      # returns next set of results. If there are no further results then the
      # continuation token is not included in the response.
      attr_accessor :continuation_token

      # @return [Boolean] Indicates whether any name under the given name has
      # been modified during the enumeration. If there was a modification, this
      # property value is false.
      attr_accessor :is_consistent

      # @return [Array<String>] List of the child names.
      attr_accessor :sub_names


      #
      # Mapper for PagedSubNameInfoList class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PagedSubNameInfoList',
          type: {
            name: 'Composite',
            class_name: 'PagedSubNameInfoList',
            model_properties: {
              continuation_token: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ContinuationToken',
                type: {
                  name: 'String'
                }
              },
              is_consistent: {
                client_side_validation: true,
                required: false,
                serialized_name: 'IsConsistent',
                type: {
                  name: 'Boolean'
                }
              },
              sub_names: {
                client_side_validation: true,
                required: false,
                serialized_name: 'SubNames',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
