# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # A record of the times when the repair task entered each state.
    #
    # This type supports the Service Fabric platform; it is not meant to be
    # used directly from your code.
    #
    class RepairTaskHistory

      include MsRestAzure

      # @return [DateTime] The time when the repair task entered the Created
      # state.
      attr_accessor :created_utc_timestamp

      # @return [DateTime] The time when the repair task entered the Claimed
      # state.
      attr_accessor :claimed_utc_timestamp

      # @return [DateTime] The time when the repair task entered the Preparing
      # state.
      attr_accessor :preparing_utc_timestamp

      # @return [DateTime] The time when the repair task entered the Approved
      # state
      attr_accessor :approved_utc_timestamp

      # @return [DateTime] The time when the repair task entered the Executing
      # state
      attr_accessor :executing_utc_timestamp

      # @return [DateTime] The time when the repair task entered the Restoring
      # state
      attr_accessor :restoring_utc_timestamp

      # @return [DateTime] The time when the repair task entered the Completed
      # state
      attr_accessor :completed_utc_timestamp

      # @return [DateTime] The time when the repair task started the health
      # check in the Preparing state.
      attr_accessor :preparing_health_check_start_utc_timestamp

      # @return [DateTime] The time when the repair task completed the health
      # check in the Preparing state.
      attr_accessor :preparing_health_check_end_utc_timestamp

      # @return [DateTime] The time when the repair task started the health
      # check in the Restoring state.
      attr_accessor :restoring_health_check_start_utc_timestamp

      # @return [DateTime] The time when the repair task completed the health
      # check in the Restoring state.
      attr_accessor :restoring_health_check_end_utc_timestamp


      #
      # Mapper for RepairTaskHistory class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RepairTaskHistory',
          type: {
            name: 'Composite',
            class_name: 'RepairTaskHistory',
            model_properties: {
              created_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CreatedUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              claimed_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ClaimedUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              preparing_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PreparingUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              approved_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ApprovedUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              executing_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ExecutingUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              restoring_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RestoringUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              completed_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CompletedUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              preparing_health_check_start_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PreparingHealthCheckStartUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              preparing_health_check_end_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PreparingHealthCheckEndUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              restoring_health_check_start_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RestoringHealthCheckStartUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              restoring_health_check_end_utc_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RestoringHealthCheckEndUtcTimestamp',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
