# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Describes a service fabric application resource.
    #
    class ApplicationResourceDescription

      include MsRestAzure

      # @return [String] User readable description of the application.
      attr_accessor :description

      # @return [String] Internal use.
      attr_accessor :debug_params

      # @return [Array<ServiceResourceDescription>] describes the services in
      # the application.
      attr_accessor :services

      # @return [HealthState] Describes the health state of an application
      # resource. Possible values include: 'Invalid', 'Ok', 'Warning', 'Error',
      # 'Unknown'
      attr_accessor :health_state

      # @return [String] When the application's health state is not 'Ok', this
      # additional details from service fabric Health Manager for the user to
      # know why the application is marked unhealthy.
      attr_accessor :unhealthy_evaluation

      # @return [ApplicationResourceStatus] Status of the application resource.
      # Possible values include: 'Invalid', 'Ready', 'Upgrading', 'Creating',
      # 'Deleting', 'Failed'
      attr_accessor :status

      # @return [String] Gives additional information about the current status
      # of the application deployment.
      attr_accessor :status_details

      # @return [Array<String>] Names of the services in the application.
      attr_accessor :service_names

      # @return [DiagnosticsDescription] Describes the diagnostics definition
      # and usage for an application resource.
      attr_accessor :diagnostics

      # @return [String] Application resource name.
      attr_accessor :name


      #
      # Mapper for ApplicationResourceDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationResourceDescription',
          type: {
            name: 'Composite',
            class_name: 'ApplicationResourceDescription',
            model_properties: {
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              debug_params: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.debugParams',
                type: {
                  name: 'String'
                }
              },
              services: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.services',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ServiceResourceDescriptionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ServiceResourceDescription'
                      }
                  }
                }
              },
              health_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.healthState',
                type: {
                  name: 'String'
                }
              },
              unhealthy_evaluation: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.unhealthyEvaluation',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.status',
                type: {
                  name: 'String'
                }
              },
              status_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.statusDetails',
                type: {
                  name: 'String'
                }
              },
              service_names: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.serviceNames',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              diagnostics: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.diagnostics',
                type: {
                  name: 'Composite',
                  class_name: 'DiagnosticsDescription'
                }
              },
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
