# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Provides statistics about the Service Fabric Replicator, when it is
    # functioning in a ActiveSecondary role.
    #
    class SecondaryReplicatorStatus < ReplicatorStatus

      include MsRestAzure


      def initialize
        @Kind = "SecondaryReplicatorStatus"
      end

      attr_accessor :Kind

      # @return [ReplicatorQueueStatus] Details about the replication queue on
      # the secondary replicator.
      attr_accessor :replication_queue_status

      # @return [DateTime] The last time-stamp (UTC) at which a replication
      # operation was received from the primary.
      # UTC 0 represents an invalid value, indicating that a replication
      # operation message was never received.
      attr_accessor :last_replication_operation_received_time_utc

      # @return [Boolean] Value that indicates whether the replica is currently
      # being built.
      attr_accessor :is_in_build

      # @return [ReplicatorQueueStatus] Details about the copy queue on the
      # secondary replicator.
      attr_accessor :copy_queue_status

      # @return [DateTime] The last time-stamp (UTC) at which a copy operation
      # was received from the primary.
      # UTC 0 represents an invalid value, indicating that a copy operation
      # message was never received.
      attr_accessor :last_copy_operation_received_time_utc

      # @return [DateTime] The last time-stamp (UTC) at which an acknowledgment
      # was sent to the primary replicator.
      # UTC 0 represents an invalid value, indicating that an acknowledgment
      # message was never sent.
      attr_accessor :last_acknowledgement_sent_time_utc


      #
      # Mapper for SecondaryReplicatorStatus class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SecondaryReplicatorStatus',
          type: {
            name: 'Composite',
            class_name: 'SecondaryReplicatorStatus',
            model_properties: {
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              replication_queue_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ReplicationQueueStatus',
                type: {
                  name: 'Composite',
                  class_name: 'ReplicatorQueueStatus'
                }
              },
              last_replication_operation_received_time_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastReplicationOperationReceivedTimeUtc',
                type: {
                  name: 'DateTime'
                }
              },
              is_in_build: {
                client_side_validation: true,
                required: false,
                serialized_name: 'IsInBuild',
                type: {
                  name: 'Boolean'
                }
              },
              copy_queue_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CopyQueueStatus',
                type: {
                  name: 'Composite',
                  class_name: 'ReplicatorQueueStatus'
                }
              },
              last_copy_operation_received_time_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastCopyOperationReceivedTimeUtc',
                type: {
                  name: 'DateTime'
                }
              },
              last_acknowledgement_sent_time_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastAcknowledgementSentTimeUtc',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
