# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_4_0_36
  module Models
    #
    # Container Exited event.
    #
    class ApplicationContainerInstanceExitedEvent < ApplicationEvent

      include MsRestAzure


      def initialize
        @Kind = "ApplicationContainerInstanceExited"
      end

      attr_accessor :Kind

      # @return [String] Name of Service.
      attr_accessor :service_name

      # @return [String] Name of Service package.
      attr_accessor :service_package_name

      # @return [String] Activation Id of Service package.
      attr_accessor :service_package_activation_id

      # @return [Boolean] Indicates IsExclusive flag.
      attr_accessor :is_exclusive

      # @return [String] Name of Code package.
      attr_accessor :code_package_name

      # @return [String] Type of EntryPoint.
      attr_accessor :entry_point_type

      # @return [String] Name of Container image.
      attr_accessor :image_name

      # @return [String] Name of Container.
      attr_accessor :container_name

      # @return [String] Host Id.
      attr_accessor :host_id

      # @return [Integer] Exit code of process.
      attr_accessor :exit_code

      # @return [Boolean] Indicates if termination is unexpected.
      attr_accessor :unexpected_termination

      # @return [DateTime] Start time of process.
      attr_accessor :start_time


      #
      # Mapper for ApplicationContainerInstanceExitedEvent class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationContainerInstanceExited',
          type: {
            name: 'Composite',
            class_name: 'ApplicationContainerInstanceExitedEvent',
            model_properties: {
              event_instance_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'EventInstanceId',
                type: {
                  name: 'String'
                }
              },
              category: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Category',
                type: {
                  name: 'String'
                }
              },
              time_stamp: {
                client_side_validation: true,
                required: true,
                serialized_name: 'TimeStamp',
                type: {
                  name: 'DateTime'
                }
              },
              has_correlated_events: {
                client_side_validation: true,
                required: false,
                serialized_name: 'HasCorrelatedEvents',
                type: {
                  name: 'Boolean'
                }
              },
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              application_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ApplicationId',
                type: {
                  name: 'String'
                }
              },
              service_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ServiceName',
                type: {
                  name: 'String'
                }
              },
              service_package_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ServicePackageName',
                type: {
                  name: 'String'
                }
              },
              service_package_activation_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ServicePackageActivationId',
                type: {
                  name: 'String'
                }
              },
              is_exclusive: {
                client_side_validation: true,
                required: true,
                serialized_name: 'IsExclusive',
                type: {
                  name: 'Boolean'
                }
              },
              code_package_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'CodePackageName',
                type: {
                  name: 'String'
                }
              },
              entry_point_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'EntryPointType',
                type: {
                  name: 'String'
                }
              },
              image_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ImageName',
                type: {
                  name: 'String'
                }
              },
              container_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ContainerName',
                type: {
                  name: 'String'
                }
              },
              host_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'HostId',
                type: {
                  name: 'String'
                }
              },
              exit_code: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ExitCode',
                type: {
                  name: 'Number'
                }
              },
              unexpected_termination: {
                client_side_validation: true,
                required: true,
                serialized_name: 'UnexpectedTermination',
                type: {
                  name: 'Boolean'
                }
              },
              start_time: {
                client_side_validation: true,
                required: true,
                serialized_name: 'StartTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
