# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_4_0_36
  module Models
    #
    # Defines a repetition rule and parameters of Chaos to be used with the
    # Chaos Schedule.
    #
    class ChaosScheduleJob

      include MsRestAzure

      # @return [String] A reference to which Chaos Parameters of the Chaos
      # Schedule to use.
      attr_accessor :chaos_parameters

      # @return [ChaosScheduleJobActiveDaysOfWeek] Defines the days of the week
      # that a Chaos Schedule Job will run for.
      attr_accessor :days

      # @return [Array<TimeRange>] A list of Time Ranges that specify when
      # during active days that this job will run. The times are interpreted as
      # UTC.
      attr_accessor :times


      #
      # Mapper for ChaosScheduleJob class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ChaosScheduleJob',
          type: {
            name: 'Composite',
            class_name: 'ChaosScheduleJob',
            model_properties: {
              chaos_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ChaosParameters',
                type: {
                  name: 'String'
                }
              },
              days: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Days',
                type: {
                  name: 'Composite',
                  class_name: 'ChaosScheduleJobActiveDaysOfWeek'
                }
              },
              times: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Times',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TimeRangeElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'TimeRange'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
