# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_4_0_36
  module Models
    #
    # Information about a cluster upgrade.
    #
    class ClusterUpgradeProgressObject

      include MsRestAzure

      # @return [String] The ServiceFabric code version of the cluster.
      attr_accessor :code_version

      # @return [String] The cluster configuration version (specified in the
      # cluster manifest).
      attr_accessor :config_version

      # @return [Array<UpgradeDomainInfo>] List of upgrade domains and their
      # statuses.
      attr_accessor :upgrade_domains

      # @return [UpgradeState] The state of the upgrade domain. Possible values
      # include: 'Invalid', 'RollingBackInProgress', 'RollingBackCompleted',
      # 'RollingForwardPending', 'RollingForwardInProgress',
      # 'RollingForwardCompleted', 'Failed'
      attr_accessor :upgrade_state

      # @return [String] The name of the next upgrade domain to be processed.
      attr_accessor :next_upgrade_domain

      # @return [UpgradeMode] The mode used to monitor health during a rolling
      # upgrade. The values are UnmonitoredAuto, UnmonitoredManual, and
      # Monitored. Possible values include: 'Invalid', 'UnmonitoredAuto',
      # 'UnmonitoredManual', 'Monitored'. Default value: 'UnmonitoredAuto' .
      attr_accessor :rolling_upgrade_mode

      # @return [ClusterUpgradeDescriptionObject] Represents a ServiceFabric
      # cluster upgrade
      attr_accessor :upgrade_description

      # @return [String] The estimated elapsed time spent processing the
      # current overall upgrade.
      attr_accessor :upgrade_duration_in_milliseconds

      # @return [String] The estimated elapsed time spent processing the
      # current upgrade domain.
      attr_accessor :upgrade_domain_duration_in_milliseconds

      # @return [Array<HealthEvaluationWrapper>] List of health evaluations
      # that resulted in the current aggregated health state.
      attr_accessor :unhealthy_evaluations

      # @return [CurrentUpgradeDomainProgressInfo] Information about the
      # current in-progress upgrade domain.
      attr_accessor :current_upgrade_domain_progress

      # @return [String] The start time of the upgrade in UTC.
      attr_accessor :start_timestamp_utc

      # @return [String] The failure time of the upgrade in UTC.
      attr_accessor :failure_timestamp_utc

      # @return [FailureReason] The cause of an upgrade failure that resulted
      # in FailureAction being executed. Possible values include: 'None',
      # 'Interrupted', 'HealthCheck', 'UpgradeDomainTimeout',
      # 'OverallUpgradeTimeout'
      attr_accessor :failure_reason

      # @return [FailedUpgradeDomainProgressObject] The detailed upgrade
      # progress for nodes in the current upgrade domain at the point of
      # failure.
      attr_accessor :upgrade_domain_progress_at_failure


      #
      # Mapper for ClusterUpgradeProgressObject class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ClusterUpgradeProgressObject',
          type: {
            name: 'Composite',
            class_name: 'ClusterUpgradeProgressObject',
            model_properties: {
              code_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CodeVersion',
                type: {
                  name: 'String'
                }
              },
              config_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ConfigVersion',
                type: {
                  name: 'String'
                }
              },
              upgrade_domains: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeDomains',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UpgradeDomainInfoElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UpgradeDomainInfo'
                      }
                  }
                }
              },
              upgrade_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeState',
                type: {
                  name: 'String'
                }
              },
              next_upgrade_domain: {
                client_side_validation: true,
                required: false,
                serialized_name: 'NextUpgradeDomain',
                type: {
                  name: 'String'
                }
              },
              rolling_upgrade_mode: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RollingUpgradeMode',
                default_value: 'UnmonitoredAuto',
                type: {
                  name: 'String'
                }
              },
              upgrade_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeDescription',
                type: {
                  name: 'Composite',
                  class_name: 'ClusterUpgradeDescriptionObject'
                }
              },
              upgrade_duration_in_milliseconds: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeDurationInMilliseconds',
                type: {
                  name: 'String'
                }
              },
              upgrade_domain_duration_in_milliseconds: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeDomainDurationInMilliseconds',
                type: {
                  name: 'String'
                }
              },
              unhealthy_evaluations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UnhealthyEvaluations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'HealthEvaluationWrapperElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'HealthEvaluationWrapper'
                      }
                  }
                }
              },
              current_upgrade_domain_progress: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CurrentUpgradeDomainProgress',
                type: {
                  name: 'Composite',
                  class_name: 'CurrentUpgradeDomainProgressInfo'
                }
              },
              start_timestamp_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'StartTimestampUtc',
                type: {
                  name: 'String'
                }
              },
              failure_timestamp_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'FailureTimestampUtc',
                type: {
                  name: 'String'
                }
              },
              failure_reason: {
                client_side_validation: true,
                required: false,
                serialized_name: 'FailureReason',
                type: {
                  name: 'String'
                }
              },
              upgrade_domain_progress_at_failure: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UpgradeDomainProgressAtFailure',
                type: {
                  name: 'Composite',
                  class_name: 'FailedUpgradeDomainProgressObject'
                }
              }
            }
          }
        }
      end
    end
  end
end
