# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_5_0_36
  module Models
    #
    # Represents the state of the secondary replicator from the primary
    # replicator’s point of view.
    #
    class RemoteReplicatorStatus

      include MsRestAzure

      # @return [String] Represents the replica ID of the remote secondary
      # replicator.
      attr_accessor :replica_id

      # @return [DateTime] The last timestamp (in UTC) when an acknowledgement
      # from the secondary replicator was processed on the primary.
      # UTC 0 represents an invalid value, indicating that no acknowledgement
      # messages were ever processed.
      attr_accessor :last_acknowledgement_processed_time_utc

      # @return [String] The highest replication operation sequence number that
      # the secondary has received from the primary.
      attr_accessor :last_received_replication_sequence_number

      # @return [String] The highest replication operation sequence number that
      # the secondary has applied to its state.
      attr_accessor :last_applied_replication_sequence_number

      # @return [Boolean] A value that indicates whether the secondary replica
      # is in the process of being built.
      attr_accessor :is_in_build

      # @return [String] The highest copy operation sequence number that the
      # secondary has received from the primary.
      # A value of -1 implies that the secondary has received all copy
      # operations.
      attr_accessor :last_received_copy_sequence_number

      # @return [String] The highest copy operation sequence number that the
      # secondary has applied to its state.
      # A value of -1 implies that the secondary has applied all copy
      # operations and the copy process is complete.
      attr_accessor :last_applied_copy_sequence_number

      # @return [RemoteReplicatorAcknowledgementStatus] Represents the
      # acknowledgment status for the remote secondary replicator.
      attr_accessor :remote_replicator_acknowledgement_status


      #
      # Mapper for RemoteReplicatorStatus class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RemoteReplicatorStatus',
          type: {
            name: 'Composite',
            class_name: 'RemoteReplicatorStatus',
            model_properties: {
              replica_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ReplicaId',
                type: {
                  name: 'String'
                }
              },
              last_acknowledgement_processed_time_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastAcknowledgementProcessedTimeUtc',
                type: {
                  name: 'DateTime'
                }
              },
              last_received_replication_sequence_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastReceivedReplicationSequenceNumber',
                type: {
                  name: 'String'
                }
              },
              last_applied_replication_sequence_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastAppliedReplicationSequenceNumber',
                type: {
                  name: 'String'
                }
              },
              is_in_build: {
                client_side_validation: true,
                required: false,
                serialized_name: 'IsInBuild',
                type: {
                  name: 'Boolean'
                }
              },
              last_received_copy_sequence_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastReceivedCopySequenceNumber',
                type: {
                  name: 'String'
                }
              },
              last_applied_copy_sequence_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastAppliedCopySequenceNumber',
                type: {
                  name: 'String'
                }
              },
              remote_replicator_acknowledgement_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RemoteReplicatorAcknowledgementStatus',
                type: {
                  name: 'Composite',
                  class_name: 'RemoteReplicatorAcknowledgementStatus'
                }
              }
            }
          }
        }
      end
    end
  end
end
