# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Information about a stateful service replica deployed on a node.
    #
    class DeployedStatefulServiceReplicaInfo < DeployedServiceReplicaInfo

      include MsRestAzure


      def initialize
        @ServiceKind = "Stateful"
      end

      attr_accessor :ServiceKind

      # @return [String] Id of a stateful service replica. ReplicaId is used by
      # Service Fabric to uniquely identify a replica of a partition. It is
      # unique within a partition and does not change for the lifetime of the
      # replica. If a replica gets dropped and another replica gets created on
      # the same node for the same partition, it will get a different value for
      # the id. Sometimes the id of a stateless service instance is also
      # referred as a replica id.
      attr_accessor :replica_id

      # @return [ReplicaRole] The role of a replica of a stateful service.
      # Possible values include: 'Unknown', 'None', 'Primary', 'IdleSecondary',
      # 'ActiveSecondary'
      attr_accessor :replica_role

      # @return [ReconfigurationInformation] Information about current
      # reconfiguration like phase, type, previous configuration role of
      # replica and reconfiguration start date time.
      attr_accessor :reconfiguration_information


      #
      # Mapper for DeployedStatefulServiceReplicaInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Stateful',
          type: {
            name: 'Composite',
            class_name: 'DeployedStatefulServiceReplicaInfo',
            model_properties: {
              service_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServiceName',
                type: {
                  name: 'String'
                }
              },
              service_type_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServiceTypeName',
                type: {
                  name: 'String'
                }
              },
              service_manifest_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServiceManifestName',
                type: {
                  name: 'String'
                }
              },
              code_package_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CodePackageName',
                type: {
                  name: 'String'
                }
              },
              partition_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PartitionId',
                type: {
                  name: 'String'
                }
              },
              replica_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ReplicaStatus',
                type: {
                  name: 'String'
                }
              },
              address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Address',
                type: {
                  name: 'String'
                }
              },
              service_package_activation_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServicePackageActivationId',
                type: {
                  name: 'String'
                }
              },
              host_process_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'HostProcessId',
                type: {
                  name: 'String'
                }
              },
              ServiceKind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ServiceKind',
                type: {
                  name: 'String'
                }
              },
              replica_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ReplicaId',
                type: {
                  name: 'String'
                }
              },
              replica_role: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ReplicaRole',
                type: {
                  name: 'String'
                }
              },
              reconfiguration_information: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ReconfigurationInformation',
                type: {
                  name: 'Composite',
                  class_name: 'ReconfigurationInformation'
                }
              }
            }
          }
        }
      end
    end
  end
end
