# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Represents the health state chunk of a stateful service replica or a
    # stateless service instance.
    # The replica health state contains the replica ID and its aggregated
    # health state.
    #
    class ReplicaHealthStateChunk < EntityHealthStateChunk

      include MsRestAzure

      # @return [String] Id of a stateful service replica or a stateless
      # service instance. This ID is used in the queries that apply to both
      # stateful and stateless services. It is used by Service Fabric to
      # uniquely identify a replica of a partition of a stateful service or an
      # instance of a stateless service partition. It is unique within a
      # partition and does not change for the lifetime of the replica or the
      # instance. If a stateful replica gets dropped and another replica gets
      # created on the same node for the same partition, it will get a
      # different value for the ID. If a stateless instance is failed over on
      # the same or different node it will get a different value for the ID.
      attr_accessor :replica_or_instance_id


      #
      # Mapper for ReplicaHealthStateChunk class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ReplicaHealthStateChunk',
          type: {
            name: 'Composite',
            class_name: 'ReplicaHealthStateChunk',
            model_properties: {
              health_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'HealthState',
                type: {
                  name: 'String'
                }
              },
              replica_or_instance_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ReplicaOrInstanceId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
