# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Describes the policy to be used for placement of a Service Fabric service
    # where two replicas from the same partition should never be placed in the
    # same fault or upgrade domain.
    #
    # While this is not common it can expose the service to an increased risk
    # of concurrent failures due to unplanned outages or other cases of
    # subsequent/concurrent failures. As an example, consider a case where
    # replicas are deployed across different data center, with one replica per
    # location. In the event that one of the datacenters goes offline, normally
    # the replica that was placed in that datacenter will be packed into one of
    # the remaining datacenters. If this is not desirable then this policy
    # should be set.
    #
    class ServicePlacementRequireDomainDistributionPolicyDescription < ServicePlacementPolicyDescription

      include MsRestAzure


      def initialize
        @Type = "RequireDomainDistribution"
      end

      attr_accessor :Type

      # @return [String] The name of the domain that should used for placement
      # as per this policy.
      attr_accessor :domain_name


      #
      # Mapper for ServicePlacementRequireDomainDistributionPolicyDescription
      # class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RequireDomainDistribution',
          type: {
            name: 'Composite',
            class_name: 'ServicePlacementRequireDomainDistributionPolicyDescription',
            model_properties: {
              Type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Type',
                type: {
                  name: 'String'
                }
              },
              domain_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DomainName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
